/* Sistemas Integrados TECNISA
   Planejamento Alimentao Industrial

Nome: 7778_PLATMPS_CORRIGE_CARDAPIO

Descrio:
   * ***********************************************************************************
   * CORRECAO DE INCONSISTENCIAS NA BASE DE DADOS DOS MDULOS
   * - PLA e PAH - TABELAS CARDADIA e COMPCARD.
   * ***********************************************************************************
Criao: Dmaso 28/01/2004
Insero da chamada do script no programa de cardpio: 01/07/2004

*/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'CORRIGE_CONFIG_CARD'  and
            type = 'P'                  and
            u.uid = o.uid               and
            u.name = USER)
  DROP PROCEDURE CORRIGE_CONFIG_CARD
  GO

CREATE PROCEDURE CORRIGE_CONFIG_CARD
   @P_CDFILIAL   VARCHAR(4),
   @P_CDSERVFILI VARCHAR(5),
   @P_DTMESCARD  DATETIME
AS
   DECLARE @C_CONFIG_CDFILIAL VARCHAR(4);
   DECLARE @C_CONFIG_NRCARDAPIO VARCHAR(10);
   DECLARE @C_CONFIG_NRSEQPRATCAR INT;

   DECLARE @C_PRATOS_CDFILIAL    VARCHAR(4);
   DECLARE @C_PRATOS_NRCARDAPIO  VARCHAR(10);
   DECLARE @C_PRATOS_NRSEQCNFMES INT;
   DECLARE @C_PRATOS_NRORDCNFMES INT;
   DECLARE @C_PRATOS_CDTIPOPRAT  VARCHAR(2);

   DECLARE @V_RESULT   INT;
BEGIN
   /* ATUALIZA REGISTROS COM NRORDCNFMES NULL */
   UPDATE CONFCARD
   SET NRORDCNFCARD = NRSEQCNFCARD
   WHERE
      CDFILIAL     = @P_CDFILIAL   AND
      CDSERVFILI   = @P_CDSERVFILI AND
      NRORDCNFCARD IS NULL;

   UPDATE CNFCAMES
   SET NRORDCNFMES = NRSEQCNFMES
   WHERE
      CDFILIAL     = @P_CDFILIAL   AND
      CDSERVFILI   = @P_CDSERVFILI AND
      DTREFECNFMES = @P_DTMESCARD  AND
      NRORDCNFMES IS NULL;

   /* Procura por pratos que perderam a referncia da CNFCAMES */
   /* Procedimento: EXCLUIR REGISTRO DA COMPCARD */
   SET @V_RESULT = 0;
   SELECT
      @V_RESULT = COUNT(*)
   FROM CNFCAMES
   WHERE
       CDFILIAL   = @P_CDFILIAL   AND
       CDSERVFILI = @P_CDSERVFILI AND
       DTREFECNFMES  = @P_DTMESCARD;

   IF @V_RESULT <> 0 BEGIN
      DECLARE C_CONFIG CURSOR FOR
       SELECT C.CDFILIAL, C.NRCARDAPIO, C.NRSEQPRATCAR
       FROM
          COMPCARD C,
          CARDADIA D
       WHERE
          D.CDFILIAL   = @P_CDFILIAL   AND
          D.CDSERVFILI = @P_CDSERVFILI AND
          D.DTMESCARD  = @P_DTMESCARD  AND
          C.CDFILIAL   = D.CDFILIAL   AND
          C.NRCARDAPIO = D.NRCARDAPIO AND
          NOT EXISTS
          (SELECT *
           FROM
              CNFCAMES
           WHERE
              CDFILIAL     = D.CDFILIAL   AND
              CDSERVFILI   = D.CDSERVFILI AND
              DTREFECNFMES = D.DTMESCARD  AND
              NRSEQCNFMES  = C.NRSEQPRATCAR);

      OPEN C_CONFIG;
      FETCH NEXT FROM C_CONFIG INTO @C_CONFIG_CDFILIAL,
                                    @C_CONFIG_NRCARDAPIO,
                                    @C_CONFIG_NRSEQPRATCAR;
      WHILE (@@FETCH_STATUS = 0) BEGIN
         DELETE FROM COMPCARD
         WHERE CDFILIAL     = @C_CONFIG_CDFILIAL   AND
               NRCARDAPIO   = @C_CONFIG_NRCARDAPIO AND
               NRSEQPRATCAR = @C_CONFIG_NRSEQPRATCAR;

         FETCH NEXT FROM C_CONFIG INTO @C_CONFIG_CDFILIAL,
                                       @C_CONFIG_NRCARDAPIO,
                                       @C_CONFIG_NRSEQPRATCAR;
      END;
      CLOSE C_CONFIG;
      DEALLOCATE C_CONFIG;
   END;
   /* Procura por pratos cujos campos NRORDPRATCAR e CDTIPOPRAT no tenham correspondentes na CNFCAMES */
   /* Procedimento: ATUALIZAR o NRORDPRATCAR e CDTIPOPRAT dos pratos */
   DECLARE C_PRATOS CURSOR FOR
    SELECT C.CDFILIAL, C.NRCARDAPIO, F.NRSEQCNFMES, F.NRORDCNFMES, F.CDTIPOPRAT
    FROM COMPCARD C, CNFCAMES F, CARDADIA B
    WHERE
       B.CDFILIAL     = @P_CDFILIAL    AND
       B.CDSERVFILI   = @P_CDSERVFILI  AND
       B.DTMESCARD    = @P_DTMESCARD   AND
       C.CDFILIAL     = B.CDFILIAL     AND
       C.NRCARDAPIO   = B.NRCARDAPIO   AND
       F.CDFILIAL     = B.CDFILIAL     AND
       F.CDSERVFILI   = B.CDSERVFILI   AND
       F.DTREFECNFMES = B.DTMESCARD    AND
       F.NRSEQCNFMES  = C.NRSEQPRATCAR AND
       (F.NRORDCNFMES <> C.NRORDPRATCAR OR F.CDTIPOPRAT <> C.CDTIPOPRAT);

   OPEN C_PRATOS;
   FETCH NEXT FROM C_PRATOS INTO @C_PRATOS_CDFILIAL,
                               @C_PRATOS_NRCARDAPIO,
                               @C_PRATOS_NRSEQCNFMES,
                               @C_PRATOS_NRORDCNFMES,
                               @C_PRATOS_CDTIPOPRAT;

   WHILE (@@FETCH_STATUS = 0) BEGIN
       UPDATE COMPCARD
       SET NRORDPRATCAR = @C_PRATOS_NRORDCNFMES,
           CDTIPOPRAT   = @C_PRATOS_CDTIPOPRAT
       WHERE
          CDFILIAL      = @C_PRATOS_CDFILIAL     AND
          NRCARDAPIO    = @C_PRATOS_NRCARDAPIO   AND
          NRSEQPRATCAR  = @C_PRATOS_NRSEQCNFMES;

      FETCH NEXT FROM C_PRATOS INTO @C_PRATOS_CDFILIAL,
                                    @C_PRATOS_NRCARDAPIO,
                                    @C_PRATOS_NRSEQCNFMES,
                                    @C_PRATOS_NRORDCNFMES,
                                    @C_PRATOS_CDTIPOPRAT;
   END;
   CLOSE C_PRATOS;
   DEALLOCATE C_PRATOS;
END;
GO
